Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
EggObject Class Reference

The highest-level base class in the egg directory. More...

`#include "eggObject.h"`

Inheritance diagram for EggObject:

## Public Member Functions
| EggObject (const EggObject &copy)
virtual EggTransform * | as_transform ()
| Returns this object cross-cast to an EggTransform pointer, if it inherits from EggTransform, or NULL if it does not.
void | clear_user_data ()
| Removes *all* user data pointers from the node.
void | clear_user_data (TypeHandle type)
| Removes the user data pointer of the indicated type.
virtual TypeHandle | force_init_type ()
virtual TypeHandle | get_type () const
EggUserData * | get_user_data () const
| Returns the user data pointer most recently stored on this object, or NULL if nothing was previously stored.
EggUserData * | get_user_data (TypeHandle type) const
| Returns the user data pointer of the indicated type, if it exists, or NULL if it does not.
bool | has_user_data () const
| Returns true if a generic user data pointer has recently been set and not yet cleared, false otherwise.
bool | has_user_data (TypeHandle type) const
| Returns true if the user data pointer of the indicated type has been set, false otherwise.
EggObject & | operator= (const EggObject &copy)
void | set_user_data (EggUserData *user_data)
| Sets the user data associated with this object.
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

The highest-level base class in the egg directory.

(Almost) all things egg inherit from this.

Definition at line 29 of file eggObject.h.

## Constructor & Destructor Documentation

## ◆ EggObject() [1/2]

EggObject::EggObject | ( |  | ) |

Definition at line 22 of file eggObject.cxx.

## ◆ EggObject() [2/2]

EggObject::EggObject | ( | const EggObject & | copy | ) |

Definition at line 30 of file eggObject.cxx.

## ◆ ~EggObject()

EggObject::~EggObject | ( |  | ) |
| virtual

Definition at line 53 of file eggObject.cxx.

## Member Function Documentation

## ◆ as_transform()

EggTransform * EggObject::as_transform | ( |  | ) |
| virtual

Returns this object cross-cast to an EggTransform pointer, if it inherits from EggTransform, or NULL if it does not.

Reimplemented in EggGroup, and EggTexture.

Definition at line 150 of file eggObject.cxx.

## ◆ clear_user_data() [1/2]

void EggObject::clear_user_data | ( |  | ) |

Removes *all* user data pointers from the node.

Definition at line 125 of file eggObject.cxx.

## ◆ clear_user_data() [2/2]

void EggObject::clear_user_data | ( | TypeHandle | type | ) |

Removes the user data pointer of the indicated type.

Definition at line 134 of file eggObject.cxx.

## ◆ force_init_type()

virtual TypeHandle EggObject::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from TypedReferenceCount.

Definition at line 65 of file eggObject.h.

## ◆ get_class_type()

static TypeHandle EggObject::get_class_type | ( |  | ) |
| inline static

Definition at line 54 of file eggObject.h.

## ◆ get_type()

virtual TypeHandle EggObject::get_type | ( |  | ) | const
| inline virtual

Reimplemented from TypedReferenceCount.

Definition at line 62 of file eggObject.h.

## ◆ get_user_data() [1/2]

EggUserData * EggObject::get_user_data | ( |  | ) | const

Returns the user data pointer most recently stored on this object, or NULL if nothing was previously stored.

Definition at line 83 of file eggObject.cxx.

Referenced by MayaNodeTree::get_egg_group(), and EggBinner::sorts_less().

## ◆ get_user_data() [2/2]

EggUserData * EggObject::get_user_data | ( | TypeHandle | type | ) | const

Returns the user data pointer of the indicated type, if it exists, or NULL if it does not.

Definition at line 92 of file eggObject.cxx.

## ◆ has_user_data() [1/2]

bool EggObject::has_user_data | ( |  | ) | const

Returns true if a generic user data pointer has recently been set and not yet cleared, false otherwise.

Definition at line 106 of file eggObject.cxx.

Referenced by MayaNodeTree::get_egg_group().

## ◆ has_user_data() [2/2]

bool EggObject::has_user_data | ( | TypeHandle | type | ) | const

Returns true if the user data pointer of the indicated type has been set, false otherwise.

Definition at line 115 of file eggObject.cxx.

## ◆ init_type()

static void EggObject::init_type | ( |  | ) |
| inline static

Definition at line 57 of file eggObject.h.

## ◆ operator=()

EggObject & EggObject::operator= | ( | const EggObject & | copy | ) |

Definition at line 42 of file eggObject.cxx.

## ◆ set_user_data()

void EggObject::set_user_data | ( | EggUserData * | user_data | ) |

Sets the user data associated with this object.

This may be any EggUserData-derived object. The egg library will do nothing with this pointer, except to hold its reference count and return the pointer on request.

The EggObject maintains multiple different EggUserData pointers, one for each unique type (as reported by get_type()). If you know that only one type of EggUserData object will be added in your application, you may use the query functions that accept no parameters, but it is recommended that in general you pass in the type of your particular user data, to allow multiple applications to coexist in the same egg data.

This pointer is also copied by the copy assignment operator and copy constructor.

Definition at line 73 of file eggObject.cxx.

Referenced by MayaNodeTree::get_egg_group(), and EggBinner::prepare_node().

The documentation for this class was generated from the following files:

- panda/src/egg/eggObject.h
- panda/src/egg/eggObject.cxx